<?php
/*
+--------------------------------------------------------------------------
|   IPBTracker v1.x
|   =============================================
|   by Jaggi
|   (c) 2002 - 2006 IPBTracker.eu.
|   =============================================
| 	Web: http://www.IPBTracker.eu
|	Release:
|	Email:
+---------------------------------------------------------------------------
+---------------------------------------------------------------------------
|
|   > IPBTracker Installation Script. 
| 	> Adds DB files, templates and IPB settings for acp.
|   > Date started: 21st Augest 2006
+--------------------------------------------------------------------------
*/

define( 'THIS_ROOT_PATH', './' );

//+------------------------------------------------------------------------
// ROOT TO REST OF IPB (SHOULD BE ABLE TO LEAVE AS-IS
//+------------------------------------------------------------------------

define( 'IPB_LOAD_SQL'   , 'admin_queries' );
define( 'IPB_THIS_SCRIPT', 'install');

require_once( '../init.php' );

$INFO = array();

//--------------------------------
// Require our global functions
//--------------------------------

require ROOT_PATH   . "conf_global.php";
require ROOT_PATH   . "sources/ipsclass.php";
require KERNEL_PATH . "class_converge.php";

# Initiate super-class
$ipsclass       = new ipsclass();
$ipsclass->vars = $INFO;

//--------------------------------
// Load the DB driver and such
//--------------------------------

$ipsclass->init_db_connection();

//--------------------------------
//  Set up our vars
//--------------------------------

$ipsclass->parse_incoming();

//--------------------------------
//  Set converge
//--------------------------------

$ipsclass->converge = new class_converge( $ipsclass->DB );

//--------------------------------
//  Initialize the FUNC
//--------------------------------

$ipsclass->initiate_ipsclass();

//--------------------------------
//  Set up our vars
//--------------------------------

$ipsclass->base_url  = 'install.php?';

//--------------------------------
// OG
//--------------------------------

$setup =  new install_me();
$setup->ipsclass =& $ipsclass;
$setup->autorun();

/**
* main core class
*
*/
class install_me
{
	var $ipsclass;
	var $xml_file      = "ipbtracker_skins.xml";
	var $settings_file = "ipb_settings.xml";
	var $tables		   = "mysql_tables.php";
	var $inserts	   = "mysql_inserts.php";
	var $contents = "";
	
	function autorun()
	{
	
	//-----------------------------------------------
	// Setup up our switch
	//-----------------------------------------------
	
		switch($this->ipsclass->input['ins'])
		{			
			case 'settings':
				$this->do_settings();
				break;
								
			case 'templates':
				$this->do_templates();
				break;
				
			case 'rebuild':
				$this->rebuild_templates();
				break;
				
			case 'database':
				$this->do_database();
				break;
				
			default:
				$this->do_intro();
				break;
		}
	}
	
/*-------------------------------------------------------------------------*/
// DO INTRO
/*-------------------------------------------------------------------------*/

	function do_intro()
	{
		$this->print_top('Welcome');
		
		$this->contents .= "<div class='centerbox'>
							<div class='tableborder'>
							<div class='maintitle'>IPBTracker Installation </div>
							<div class='tablepad'>
							<table width='80%' border='0' cellpadding='0' cellspacing='0' align='center'>
								<tr>
								<br /><br />
								<td>
									<div class='header'>Welcome to IPBTracker</div>
									<br />Before we go any further, please ensure that all the files have been uploaded.
									<br /><br />Once you have clicked on continue, you will be prompted to install the various parts of IPBTracker. This is a automatic process and just requires your confirmation.
									<br /><br />
									<b><font color='#FF0000'>PLEASE NOTE: USING THIS INSTALLER WILL DELETE ANY CURRENT IPBTracker DATABASE<br />
									<br /> ALSO ANY EXISITING IPBTRACKER TEMPLATES WILL BE OVERWRITTEN SO EXPORT YOUR CHANGES IF YOU WISH TO SAVE ANYTHING.</b></font>
							</div>
							</div>
							</div>
							";
		
		//---------------------------------------			 
		// Check to make sure that the config file
		// is there and it's got suitable permissions to write to:
		//---------------------------------------
		
		$file       = ROOT_PATH."conf_global.php";
		$warnings   = array();
		$checkfiles = array( THIS_ROOT_PATH."installfiles/".$this->settings_file,
							 THIS_ROOT_PATH."installfiles/".$this->xml_file,
							 THIS_ROOT_PATH."installfiles/".$this->tables,
							 THIS_ROOT_PATH."installfiles/".$this->inserts,
							 KERNEL_PATH   ."class_converge.php",
							 KERNEL_PATH   ."class_xml.php",
							 ROOT_PATH     ."conf_global.php" );
						  
		$writeable  = array( ROOT_PATH."conf_global.php",
							 ROOT_PATH."cache",
							 ROOT_PATH."cache/lang_cache/",
							 ROOT_PATH."cache/skin_cache/" );
		
		foreach ( $checkfiles as $cf )
		{
			if ( ! file_exists($cf) )
			{
				$warnings[] = "Cannot locate the file '$cf'.";
			}
		}
		
		foreach ( $writeable as $cf )
		{
			if ( ! is_writeable($cf) )
			{
				$warnings[] = "Cannot write to the file '$cf'. Please CHMOD to 0777.";
			}
		}
		
		$this->ipsclass->DB->query("SELECT VERSION() AS version");
		$query = $this->ipsclass->DB->fetch_row();
		$mysql_version = explode('-', $query['version']);
			
		if ( $mysql_version[0] < '4.1' )
		{
			$warnings[] = "Sorry to run this modification properly you need MYSQL 4.1 or above, please update your mysql and run the script again.";
		}
		//----------------------------------
		// CHECK BASICS
		//----------------------------------
			
		if ( ! function_exists('xml_parse_into_struct') )
		{
			$warnings[] = "<b>You cannot install IPBTracker. IPBTracker requires that the XML functions in PHP are enabled, please ask your host to enable XML.</b>";
		}
		
		//----------------------------------
		// Got error?
		//----------------------------------
		
		if ( count($warnings) > 0 )
		{
			$err_string = '&middot;'.implode( "<br /><br />&middot;", $warnings );
		
			$this->contents .= "<br /><br />
								<div class='warnbox'>
								<strong>Warning!</strong>
								<b>The following errors must be rectified before continuing!</b>
								<br /><br />
								$err_string
								</div>";
		}
		else
		{
			$this->contents .= "<div align='center'>
								<b>
								<form method='post' action='?ins=settings'><input type='submit' value='Continue...' class='hand'></form><br />								
								<a href='install.php?ins=settings'>Skip to ACP Settings Installation</a><br />
								<a href='install.php?ins=templates'>Skip to Template installation</a><br />
								<a href='install.php?ins=database'>Skip to Database installation</a>	<br />						
								<a href='". $this->ipsclass->vars['board_url'] ."'>Return to your forum</a></div>
								</b>
								";
		}
		
		$this->contents .= "</td>
							</tr>
							</table>
							</div></div><br /><br />
							";
		
		$this->output();
		}
		
/*-------------------------------------------------------------------------*/
// Install ACP Settings
/*-------------------------------------------------------------------------*/
	
	function do_settings()
	{
	
	$updated      = 0;
	$inserted     = 0;
	$need_update  = array();
	$cur_settings = array();
	$new_titles   = array();
	$new_settings = array();
	
	$this->setting_titles_check();
	
	//-----------------------------------------
	// Get current settings.
	//-----------------------------------------
	
	$this->ipsclass->DB->simple_construct( array( 'select' => 'conf_id, conf_key',
												  'from'   => 'conf_settings',
												  'order'  => 'conf_id' ) );
	
	$this->ipsclass->DB->simple_exec();
	
	while ( $r = $this->ipsclass->DB->fetch_row() )
	{
		$cur_settings[ $r['conf_key'] ] = $r['conf_id'];
	}
	
	//-----------------------------------------
	// Get current titles
	//-----------------------------------------
	
	$this->setting_get_groups();
	
	//-----------------------------------
	// Get XML
	//-----------------------------------
	
	require_once( KERNEL_PATH.'class_xml.php' );
	
	$xml = new class_xml();
	
	//-----------------------------------
	// Get XML file
	//-----------------------------------
	
	if (! file_exists( THIS_ROOT_PATH.'installfiles/'.$this->settings_file ) )
	{
		$this->install_error("Unable to open ". THIS_ROOT_PATH.'installfiles/'.$this->settings_file .", file not found");
	}
	else 
	{
		$xmlfile = THIS_ROOT_PATH.'installfiles/'.$this->settings_file;
	} 
	
	$setting_content = implode( "", file($xmlfile) );
	
	//-------------------------------
	// Unpack the datafile
	//-------------------------------
	
	$xml->xml_parse_document( $setting_content );
	
	//-------------------------------
	// check settings file
	//-------------------------------
	
	if ( ! is_array( $xml->xml_array['settingexport']['settinggroup']['setting'] ) )
	{
		$this->install_error("Error with ipb_settings.xml - could not process XML properly");
	}
	
	//-----------------------------------------
	// pArse
	//-----------------------------------------
	
	$fields = array( 'conf_title'   , 'conf_description', 'conf_group'    , 'conf_type'    , 'conf_key'        , 'conf_default',
					 'conf_extra'   , 'conf_evalphp'    , 'conf_protected', 'conf_position', 'conf_start_group', 'conf_end_group',
					 'conf_help_key', 'conf_add_cache'  , 'conf_title_keyword' );
	
	$setting_fields = array( 'conf_title_keyword', 'conf_title_title', 'conf_title_desc', 'conf_title_noshow' );
	
	//-----------------------------------------
	// Fix up...
	//-----------------------------------------
	
	if ( ! is_array( $xml->xml_array['settingexport']['settinggroup']['setting'][0]  ) )
	{
		//-----------------------------------------
		// Ensure [0] is populated
		//-----------------------------------------
		
		$tmp = $xml->xml_array['settingexport']['settinggroup']['setting'];
		
		unset($xml->xml_array['settingexport']['settinggroup']['setting']);
		
		$xml->xml_array['settingexport']['settinggroup']['setting'][0] = $tmp;
	}
	
	//-----------------------------------------
	// Loop through and sort out settings...
	//-----------------------------------------
	
	foreach( $xml->xml_array['settingexport']['settinggroup']['setting'] as $id => $entry )
	{
		$newrow = array();
		
		//-----------------------------------------
		// Is setting?
		//-----------------------------------------
		
		if ( ! $entry['conf_is_title']['VALUE'] )
		{
			foreach( $fields as $f )
			{
				$newrow[$f] = $entry[ $f ]['VALUE'];
			}
			
			$new_settings[] = $newrow;
		}
		
		//-----------------------------------------
		// Is title?
		//-----------------------------------------
		
		else
		{
			foreach( $setting_fields as $f )
			{
				$newrow[$f] = $entry[ $f ]['VALUE'];
			}
			
			$new_titles[] = $newrow;
		}
	}
	
	//-----------------------------------------
	// Sort out titles...
	//-----------------------------------------
	
	if ( is_array( $new_titles ) and count( $new_titles ) )
	{
		foreach( $new_titles as $idx => $data )
		{
			if ( $data['conf_title_title'] AND $data['conf_title_keyword'] )
			{
				//-----------------------------------------
				// Get ID based on key
				//-----------------------------------------
				
				$conf_id = $this->setting_groups_by_key[ $data['conf_title_keyword'] ]['conf_title_id'];
				
				$save = array( 'conf_title_title'   => $data['conf_title_title'],
							   'conf_title_desc'    => $data['conf_title_desc'],
							   'conf_title_keyword' => $data['conf_title_keyword'],
							   'conf_title_noshow'  => $data['conf_title_noshow']  );
										
				//-----------------------------------------
				// Not got a row, insert first!
				//-----------------------------------------
				
				if ( ! $conf_id )
				{
					$this->ipsclass->DB->do_insert( 'conf_settings_titles', $save );
					$conf_id = $this->ipsclass->DB->get_insert_id();
					
				}
				else
				{
					//-----------------------------------------
					// Update...
					//-----------------------------------------
					
					$this->ipsclass->DB->do_update( 'conf_settings_titles', $save, 'conf_title_id='.$conf_id );
				}
				
				//-----------------------------------------
				// Update settings cache
				//-----------------------------------------
	
				$save['conf_title_id']                                      = $conf_id;										
				$this->setting_groups_by_key[ $save['conf_title_keyword'] ] = $save;
				$this->setting_groups[ $save['conf_title_id'] ]             = $save;
				
				//-----------------------------------------
				// Remove need update...
				//-----------------------------------------
									
				$need_update[] = $conf_id;
			}
		}
	}
	
	//-----------------------------------------
	// Sort out settings
	//-----------------------------------------
	
	if ( is_array( $new_settings ) and count( $new_settings ) )
	{
		foreach( $new_settings as $idx => $data )
		{
				
			//-----------------------------------------
			// Now assign to the correct ID based on
			// our title keyword...
			//-----------------------------------------
			
			$data['conf_group'] = $this->setting_groups_by_key[ $data['conf_title_keyword'] ]['conf_title_id'];
					
			//-----------------------------------------
			// Remove from array
			//-----------------------------------------
			
			unset( $data['conf_title_keyword'] );
			
			if ( $cur_settings[ $data['conf_key'] ] )
			{
				//-----------------------------------------
				// Update
				//-----------------------------------------
				
				$this->ipsclass->DB->do_update( 'conf_settings', $data, 'conf_id='.$cur_settings[ $data['conf_key'] ] );
				$updated++;
			}
			else
			{
				//-----------------------------------------
				// INSERT
				//-----------------------------------------
				
				$this->ipsclass->DB->do_insert( 'conf_settings', $data );
				$inserted++;
			}
		}
	}

	//-----------------------------------------
	// Update group counts...
	//-----------------------------------------
	
	if ( count( $need_update ) )
	{
		foreach( $need_update as $i => $idx )
		{
			$conf = $this->ipsclass->DB->simple_exec_query( array( 'select' => 'count(*) as count', 'from' => 'conf_settings', 'where' => 'conf_group='.$idx ) );
		
			$count = intval($conf['count']);
			
			$this->ipsclass->DB->do_update( 'conf_settings_titles', array( 'conf_title_count' => $count ), 'conf_title_id='.$idx );
		}
	}
	
	//-----------------------------------
	// ARE WE DONE? REALLY? COOL!!
	//-----------------------------------
	
	$this->print_top('Success!');
	
	$this->contents .= /*"<meta http-equiv='refresh' content='2; url=index.php?a=templates' />*/
									  "<div class='centerbox'>
									  <div class='tableborder'>
									  <div class='maintitle'>Success </div>
									  <div class='tablepad'>
									  <div align='center'>
									  <b>IPBTracker Settings have been installed! $updated settings updated $inserted settings inserted</b>
									  <br /><br />
									  The first stage of the installation is complete.
									  <br />
									  The next step will install the templates into your database...
									  <br /><br /> 									  
									  <b>
									  <form method='post' action='?ins=templates'><input type='submit' value='Continue...' class='hand'></form>
									  <a href='install.php?ins=templates'>Skip to Templates installation</a><br />
									  <a href='install.php?ins=database'>Skip to Database installation</a><br />						
									  <a href='install.php'>Back to beginning of Installation</a><br />
									  <a href='". $this->ipsclass->vars['board_url'] ."'>Return to your forum</a>
									  </b>
									  </div>								
									  </div>
									  </div>
									  </div><br /><br />";
						 
	$this->output();
	}	

/*-------------------------------------------------------------------------*/
// TEMPLATES
/*-------------------------------------------------------------------------*/
	
	function do_templates()
	{
	
	//-----------------------------------
	// Get XML
	//-----------------------------------
	
	require_once( KERNEL_PATH.'class_xml.php' );
	
	$xml = new class_xml();
	$xml->lite_parser = 1;	
	
	//-----------------------------------
	// Get XML file (TEMPLATES)
	//-----------------------------------
	
	if (! file_exists( THIS_ROOT_PATH."installfiles/".$this->xml_file ) )
	{
		$this->install_error("Unable to open ". THIS_ROOT_PATH."installfiles/".$this->xml_file .", file not found");
	}
	else 
	{
		$xmlfile = THIS_ROOT_PATH."installfiles/".$this->xml_file;
	} 
	
	$setting_content = implode( "", file($xmlfile) );
	
	//-------------------------------
	// Unpack the datafile (TEMPLATES)
	//-------------------------------
	
	$xml->xml_parse_document( $setting_content );
	
	//-------------------------------
	// (TEMPLATES)
	//-------------------------------
	
	if ( ! is_array( $xml->xml_array['ipbtracker_data']['templates']['template'] ) )
	{
		$this->install_error("Error with ipb_templates.xml - could not process XML properly");
	}

	$cache=0;
	foreach( $xml->xml_array['ipbtracker_data']['templates']['template'] as $id => $entry )
	{
		if ($cache == 0)
		{
			$this->ipsclass->DB->simple_exec_query(array('select' => '*', 'from' => 'skin_templates_cache', 'where' => "template_group_name='".$entry['group_name']['VALUE']."'"));
			if ($this->ipsclass->DB->get_num_rows())
			{
				$this->ipsclass->DB->simple_exec_query(array('delete' => 'skin_templates_cache', 'where' => "template_group_name='".$entry['group_name']['VALUE']."'"));
			}
			$cache = 1;
		}

		$this->ipsclass->DB->simple_exec_query(array('select' => '*', 'from' => 'skin_templates', 'where' => "group_name='".$entry['group_name']['VALUE']."' AND func_name='".$entry['func_name']['VALUE']."'"));
		if ($this->ipsclass->DB->get_num_rows())
		{
			$this->ipsclass->DB->simple_exec_query(array('delete' => 'skin_templates', 'where' => "group_name='".$entry['group_name']['VALUE']."' AND func_name='".$entry['func_name']['VALUE']."'"));
		}
			
		$newrow = array();
		
		$newrow['group_name']      = $entry[ 'group_name' ]['VALUE'];
		$newrow['section_content'] = $entry[ 'section_content' ]['VALUE'];
		$newrow['func_name']       = $entry[ 'func_name' ]['VALUE'];
		$newrow['func_data']       = $entry[ 'func_data' ]['VALUE'];
		$newrow['set_id']          = 1;
		$newrow['updated']         = time();
		
		$this->ipsclass->DB->do_insert( 'skin_templates', $newrow );
	}
	
		//-------------------------------
		// ARE WE DONE? REALLY? COOL!!
		//-------------------------------
	   
		$this->print_top('Success!');
	   
		$this->contents .= "
		<meta http-equiv='refresh' content='2; url=install.php?ins=rebuild' />
		<div class='centerbox'>
		<div class='tableborder'>
		<div class='maintitle'>Success</div>
		<div class='tablepad'>
		<b>Template files installed, you will automatically redirected to rebuild your template cache...</b>
		<br /><br />
		The second stage of the installation is almost complete. 
		<br /><br />
		<div><form method='post' action='?ins=rebuild'><input type='submit' value='Click here if not redirected...' class='hand'></form><div>
		</div>
		</div>
		</div>
		</div>
		<br /><br />
		";
		
		$this->output();	
	}

/*-------------------------------------------------------------------------*/
// Rebuild Template Cache
/*-------------------------------------------------------------------------*/
	
	function rebuild_templates()
	{

		require_once(ROOT_PATH.'sources/lib/admin_cache_functions.php');
		$this->cache = new admin_cache_functions($this);
		$this->cache->ipsclass =& $this->ipsclass;

		$c = ($this->ipsclass->input['skinid']) ? $this->ipsclass->input['skinid'] : 1;
		$s = $this->ipsclass->DB->simple_exec_query(array('select' => '*', 'from' => 'skin_sets', 'where' => 'set_skin_set_id>'.$c, 'order' => 'set_skin_set_id', 'limit' => array(0, 1)));

		if ($s['set_skin_set_id'])
		{
			$this->cache->_rebuild_all_caches(array($s['set_skin_set_id']));
			$this->print_top();
			$this->contents .= "<div class='centerbox'>
								<div class='tableborder'>
								<div class='maintitle'>Rebuilding Cache...</div>
								<div class='tablepad'>
								<meta http-equiv='refresh' content='0;url=?ins=rebuild&skinid={$s['set_skin_set_id']}'>Rebuilding skin: {$s['set_name']} is complete.
								<br />
								Proceed to next skin.<p><form method='post' action='?ins=rebuild&skinid={$s['set_skin_set_id']}'><input type='submit' value='Click Here If You Are Not Forwarded...' class='hand'></form>
								</div>
								</div>
								</div>
								<br /><br />
								";
			$this->output();
		}
	
		$this->print_top('Success!');
	   
		$this->contents .= "<div class='centerbox'>
							<div class='tableborder'>
							<div class='maintitle'>Success</div>
							<div class='tablepad'>
							<div align='center'>
							<b>Template files installed and cache has been installed.</b>
							<br /><br />
							The second stage of the installation is now complete. 
							<br />
							Click the button below to install the Database Modifications.
				   			<br /><br />
						    <b>
							<form method='post' action='?ins=database'><input type='submit' value='Continue...' class='hand'></form>
						    <a href='install.php?ins=settings'>Skip to ACP Settings installation</a><br />
						    <a href='install.php?ins=templates'>Skip to Templates installation</a><br />							
						    <a href='install.php'>Back to beginning of Installation</a><br />
						    <a href='". $this->ipsclass->vars['board_url'] ."'>Return to your forum</a>
							</b>
						    </div>	
							</div>
							</div>
							</div>
							</div>
							<br /><br />";
	   
		$this->output();
		
	}
	
/*-------------------------------------------------------------------------*/
// oOh Database... 
/*-------------------------------------------------------------------------*/			

	function do_database()
	{
	
	//-----------------------------------
	// Require insert files
	//-----------------------------------
	
	$checkfiles = array( THIS_ROOT_PATH."installfiles/".$this->tables,
						 THIS_ROOT_PATH."installfiles/".$this->inserts,
						);
							 
		foreach ( $checkfiles as $cf )
		{
			if ( ! file_exists($cf) )
			{
				$warnings[] = "Cannot locate the file '$cf'.";
			}
		}
			
		if ( count($warnings) > 0 )
		{
			$err_string = '&middot;'.implode( "<br /><br />&middot;", $warnings );
		
			$this->install_error( $err_string );
		}
		else
		{
		require_once( THIS_ROOT_PATH.'installfiles/'.$this->tables );
		require_once( THIS_ROOT_PATH.'installfiles/'.$this->inserts );
		}
	
	//-----------------------------------
	// Populate the database...
	//-----------------------------------
	 
		foreach( $TABLE as $q )
		{
		   preg_match("/CREATE TABLE (\S+) \(/", $q, $match);
	
			if ($match[1])
			{
				$this->ipsclass->DB->query( "DROP TABLE if exists ". $match[1] );
			}
				
			//-----------------------------------
			// Pass query
			//-----------------------------------
			
			if ( ! $this->ipsclass->DB->query($q) )
			{
				$this->install_error($q."<br /><br />".$this->ipsclass->DB->error);
			}
		}
		
	//-----------------------------------
	// Populate tables...
	//-----------------------------------
	
		foreach( $INSERTS as $q )
		{
		
			if ( SQL_PREFIX != "ibf_")
			{
			   $q = preg_replace("/ibf_(\S+?)([\s\.,]|$)/", SQL_PREFIX."\\1\\2", $q);
			}
			
			 //-----------------------------------
			 // Pass query
			 //-----------------------------------
				
			if ( ! $this->ipsclass->DB->query($q) )
			{
				$this->install_error($q."<br /><br />".$this->ipsclass->DB->error);
			}
		}			
	
	//-----------------------------------
	// Add Alters
	//-----------------------------------
	
		 foreach( $ALTERS as $q )
		 {
			if ( SQL_PREFIX != "ibf_")
			{
			   $q = preg_replace("/ibf_(\S+?)([\s\.,]|$)/", SQL_PREFIX."\\1\\2", $q);
			}
			
			//-----------------------------------
			// Pass query
			//-----------------------------------
		
			if ( ! $this->ipsclass->DB->query($q) )
			{
				$this->install_error($q."<br /><br />".$this->ipsclass->DB->error);
			}
		}
		
		$this->print_top('Success!');
	   
		$this->contents .= "<div class='centerbox'>
							<div class='tableborder'>
							<div class='maintitle'>Installation Complete</div>
							<div class='tablepad'>
							<div align='center'>
							<b>Your database has successfully been installed and configured.</b>
							<br /><br />
							The final stage of your installation is complete
							<br /><br />
						    <b>
							<a href='". $this->ipsclass->vars['board_url'] ."'>Return to your forum</a><br />
							<a href='install.php'>Back to beginning of Installation</a><br />
						    <a href='install.php?ins=settings'>Skip to ACP Settings installation</a><br />
						    <a href='install.php?ins=templates'>Skip to Templates installation</a><br />						
						    </b>
						    </div>
							</div>
							</div>
							</div>
							</div>
							<br /><br />";
	   
		$this->output();
	}
	
/*-------------------------------------------------------------------------*/
// Install Error
/*-------------------------------------------------------------------------*/

	function install_error($msg="")
	{
		$this->print_top('Warning!');
		
	
		
		$this->contents .= "<div class='warnbox'>
								 <strong style='font-size:16px;color:#F00'>Warning!</strong>
								 <br /><br />
								 <b>The following errors must be rectified before continuing!</b><br>Please go back and try again!
								 <br><br>
								 $msg
								</div>";
		
		
		
		$this->output();
	}

/*-------------------------------------------------------------------------*/
// Functions to do with ACP Config Settings
/*-------------------------------------------------------------------------*/
	
	function setting_get_groups()
	{
		$this->setting_groups = array();
		
		if ( IN_DEV )
		{
			$this->ipsclass->DB->simple_construct( array( 'select' => '*', 'from' => 'conf_settings_titles', 'order' => 'conf_title_title' ) );
			$this->ipsclass->DB->simple_exec();
		}
		else
		{
			$this->ipsclass->DB->simple_construct( array( 'select' => '*', 'from' => 'conf_settings_titles', 'where' => 'conf_title_noshow=0', 'order' => 'conf_title_title' ) );
			$this->ipsclass->DB->simple_exec();
		}
		
		while( $r = $this->ipsclass->DB->fetch_row() )
		{
			$this->setting_groups[ $r['conf_title_id'] ]             = $r;
			$this->setting_groups_by_key[ $r['conf_title_keyword'] ] = $r;
		}
	}
	
/*-------------------------------------------------------------------------*/
// More Functions to do with ACP Config Settings
/*-------------------------------------------------------------------------*/

	function setting_titles_check()
	{
		//-----------------------------------------
		// Get 'em
		//-----------------------------------------
		
		$this->ipsclass->DB->build_query( array( 'select' => '*', 'from' => 'conf_settings_titles' ) );
		$outer = $this->ipsclass->DB->exec_query();
		
		while( $row = $this->ipsclass->DB->fetch_row( $outer ) )
		{
			if ( ! $row['conf_title_keyword'] )
			{
				$new_keyword = strtolower( preg_replace( "#[^\d\w]#", "", $row['conf_title_title'] ) );
				$this->ipsclass->DB->do_update( 'conf_settings_titles', array( 'conf_title_keyword' => $new_keyword ), 'conf_title_id='.$row['conf_title_id'] );
			}
		}
	}

/*-------------------------------------------------------------------------*/
// SHOW ERROR WITH CONTINUE
/*-------------------------------------------------------------------------*/	

	function output()
	{
		$year = date('Y');
		
		echo $this->contents;
		echo "</fieldset>
		      <center><fieldset id='copy' ><a href='http://www.IPBTracker.eu'>IPBTracker</a> &copy; $year <a href='http://www.IPBTracker.eu'>IPBTracker.eu</a></center>
			  </fieldset>
			  </body>
			  </html>";
		exit();
	}
	
/*-------------------------------------------------------------------------*/
// Print Header
/*-------------------------------------------------------------------------*/

	function print_top($title="")
	{
	
		$this->contents = "<html>
		          		   <head><title>IPBTracker Installation :: $title </title>
						   <link href='img/css.css' rel='stylesheet' type='text/css' />
						   </head>
						   <body marginheight='0' marginwidth='0' leftmargin='0' topmargin='0' bgcolor='#FFFFFF'>
						   <div id='logostrip'><img src='http://www.ipbtracker.eu/logo.jpg' border='0' alt='IPBTracker Installer' /></div>
						   <fieldset id='copy'><br /><br />
						  ";
				  	   
	}
}
?>