<?php

$TABLE[] = "CREATE TABLE xbt_announce_log (
  id int NOT NULL auto_increment,
  ipa int unsigned NOT NULL,
  port int NOT NULL,
  event int NOT NULL,
  info_hash blob NOT NULL,
  peer_id blob NOT NULL,
  downloaded bigint NOT NULL,
  left0 bigint NOT NULL,
  uploaded bigint NOT NULL,
  uid int NOT NULL,
  mtime int NOT NULL,
  PRIMARY KEY (id)
);";

$TABLE[] = "CREATE TABLE xbt_config (
  name varchar(255) NOT NULL,
  value varchar(255) NOT NULL
);";

$TABLE[] = "CREATE TABLE xbt_deny_from_hosts (
  begin int NOT NULL,
  end int NOT NULL
);";


$TABLE[] = "CREATE TABLE torrents (
  fid int(11) NOT NULL auto_increment,
  info_hash blob NOT NULL,
  leechers int(11) NOT NULL default '0',
  seeders int(11) NOT NULL default '0',
  completed int(11) NOT NULL default '0',
  flags int(11) NOT NULL default '0',
  mtime int(11) NOT NULL default '0',
  ctime int(11) NOT NULL default '0',
  filename varchar(255) NOT NULL default '',
  name varchar(255) NOT NULL default '',
  size bigint(20) unsigned NOT NULL default '0',
  numfiles int(10) unsigned NOT NULL default '0',
  added int(10) NOT NULL default '0',
  type enum('single','multi') NOT NULL default 'single',
  oid mediumint(8) NOT NULL default '0',
  PRIMARY KEY  (fid),
  UNIQUE KEY info_hash (info_hash(20)),
  KEY filename (filename)
);";


$TABLE[] = "CREATE TABLE xbt_files_users (
  fid int NOT NULL,
  uid int NOT NULL,
  active tinyint NOT NULL,
  announced int NOT NULL,
  completed int NOT NULL,
  downloaded bigint(20) NOT NULL,
  `left` bigint(20) NOT NULL,
  uploaded bigint(20) NOT NULL,
  mtime int NOT NULL,
  UNIQUE KEY (fid, uid),
  KEY (uid)
);";

$TABLE[] = "CREATE TABLE xbt_scrape_log (
  id int NOT NULL auto_increment,
  ipa int NOT NULL,
  info_hash blob,
  uid int NOT NULL,
  mtime int NOT NULL,
  PRIMARY KEY (id)
);";

$TABLE[] = "CREATE TABLE users (
  uid int(11) NOT NULL default '0',
  name varchar(255) NOT NULL default '',
  pass blob NOT NULL,
  can_leech tinyint(4) NOT NULL default '1',
  wait_time int(11) NOT NULL default '0',
  peers_limit int(11) NOT NULL default '0',
  torrents_limit int(11) NOT NULL default '0',
  torrent_pass varchar(32) NOT NULL default '',
  torrent_pass_secret bigint(20) NOT NULL default '0',
  downloaded bigint(20) NOT NULL default '0',
  uploaded bigint(20) NOT NULL default '0',
  password varchar(40) NOT NULL default '',
  email varchar(80) NOT NULL default '',
  added INT( 10 ) NOT NULL DEFAULT '0',
  PRIMARY KEY  (uid),
  UNIQUE KEY name (name)
);";


?>